/*
==============================================================================

COPYRIGHT(C) 2001 Sergei Hristov Kostov             Bulgaria      city:Razgrad 

date:25.07.2001

 This file is part of mplay free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or any later version.
      
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
	      
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

==============================================================================
*/

#include <sys/types.h>
#include <stdio.h>
#include <dirent.h>
#include <stdlib.h>


class Linear_list
{ 
 private:
	int OOK,nlist;
	struct dirent **namelist;
	struct L_list
	  {
           struct L_list *prev;
	   char *name;
	   struct L_list *next;
	  };
 public:
	struct L_list *L_names,start;
	int nfiles;
	void get_namelist(const char *dir);
        void Error(char *kind,int fatal);
	void L_first();
	int L_list_Add_New(void);
	int L_list_GoTo_prev(void);
	int L_list_GoTo_next(void);
	void L_list_To_first(void);
	int Find_mods();
	void Add_To_List();
};

  void Linear_list::Error(char *kind,int fatal)
	{
	fprintf(stderr,"Report: %s\n",kind);
	if (fatal==1)
	 {
	   fprintf(stderr,"Exiting...\n");
	   exit(1);
	 };
        };
  
  void Linear_list::get_namelist(const char *dir)
	{
	 nfiles= scandir(dir, &namelist, 0, alphasort);
	  if (nfiles<0) Error("Cannot scan dir",1);
	 };
      
  void Linear_list::L_first()
      { 
      L_names=&start;
      L_names->prev=NULL;
      L_names->next=NULL;
      };
	   
       
  int Linear_list::L_list_Add_New(void)
	   {
	   struct L_list* save_prev;
	   save_prev=L_names;//zapazvane adresa na stariq element
	   L_names->next = (struct L_list*)malloc(sizeof(struct L_list));
           if(L_names->next==NULL)
	      Error("Not enough memory",1);
	   L_names=L_names->next; //prehvurlqne kum adresa na noiq element
	   L_names->prev=save_prev;//adresa na stariq element -> prev;
	   L_names->next=NULL; //za da se znae koe e krai
           };
	  
	   
  int Linear_list::L_list_GoTo_prev(void)
       {
	if (L_names->prev==&start)//tova e purviqt element
          return -1;
	L_names=L_names->prev;//prehvurlqne edin element nazad
       };
	
	
  int Linear_list::L_list_GoTo_next(void)
	{
	 if (L_names->next==NULL)// tova e posledniqt element
	  return -1;
	 L_names=L_names->next;//edin element napred
	};
	  
	  
  void Linear_list::L_list_To_first(void)
	  {
	  L_names=&start;
	  L_names=L_names->next;
	  };
	
	  
  void  Linear_list::Add_To_List()
	 {OOK=0;
	  L_list_Add_New();
	  L_names->name=namelist[nlist]->d_name;
	 };
	 
  int Linear_list::Find_mods()
       {OOK=-1;
	L_first();
	for(nlist=0;nlist<nfiles;nlist++)
	   {
	      if ( Player_Load(namelist[nlist]->d_name,8,0)!=NULL )
	       Add_To_List();
 	   };
	return OOK;
       }; 